﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ElfViewerConsole.ELFModel.ELFFormat
{
    class ELFElem64Enum<T> : ELFElem<ulong> where T : struct, IConvertible
    {
        public ELFElem64Enum(long offset, ulong value, string name)
            : base(offset, value, name, typeof(T))
        {
            if (!typeof(T).IsEnum) throw new ArgumentException("T must be an enumerated type");
        }

        public ELFElem64Enum(long offset, ulong value, string name, int? actualSize)
            : base(offset, value, name, typeof(T), actualSize)
        {
            if (!typeof(T).IsEnum) throw new ArgumentException("T must be an enumerated type");
        }

        public T GetEnumValue()
        {
            return (T)Convert.ChangeType(this.enumValue, typeof(T));
        }
    }
}
