﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace ElfViewerConsole.ELFModel.ELFFormat
{
    class ELFProgramHeaderTables
    {
        private ELFFile ElfFile;
        private ELFProgramHeaderTable[] ProgramHeaderTable;
        public bool Exists { private set; get; }
        public int NumOfProgramHeaderTables { private set; get; }

        public ELFProgramHeaderTables(ELFFile elfFile)
        {
            this.ElfFile = elfFile;
        }

        internal void Read()
        {
            if ((ElfFile.ElfFileHeader.E_Phoff.Value != 0) &&
                (ElfFile.ElfFileHeader.E_Phoff.Value + (ulong)(ElfFile.ElfFileHeader.E_PhNum.Value * ElfFile.ElfFileHeader.E_PhEntSize.Value) <= (ulong)ElfFile.FileSize))
            {
                ProgramHeaderTable = new ELFProgramHeaderTable[ElfFile.ElfFileHeader.E_PhNum.Value];
                for (int headerIndex = 0; headerIndex < ElfFile.ElfFileHeader.E_PhNum.Value; headerIndex++)
                {
                    ProgramHeaderTable[headerIndex] = new ELFProgramHeaderTable(headerIndex, ElfFile);
                    ProgramHeaderTable[headerIndex].Read(ElfFile.FileData);
                }
                Exists = true;
                NumOfProgramHeaderTables = ElfFile.ElfFileHeader.E_PhNum.Value;
            }
            else
            {
                Exists = true;
                NumOfProgramHeaderTables = ElfFile.ElfFileHeader.E_PhNum.Value;
            }
        }

        public ELFProgramHeaderTable this[int key]
        {
            get { return ProgramHeaderTable[key]; }
        }

        public IEnumerator GetEnumerator()
        {
            foreach (ELFProgramHeaderTable sec in ProgramHeaderTable)
            {
                yield return sec;
            }
        }
    }
}
