﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ElfViewerConsole.ELFModel.ELFFormat.Enums
{
    [Flags]
    public enum EELFPFlags : uint
    {
        [Description("Execute permission")]
        PF_X = 0x1,

        [Description("Write permission")]
        PF_W = 0x2,

        [Description("Read permission")]
        PF_R = 0x4,

        [Description("Environment-speciﬁc use")]
        PF_MASKOS = 0x00FF0000,

        [Description("Environment-speciﬁc use")]
        PF_MASKPROC = 0xFF000000
    }

    public static class EELFPFlagsExtension
    {
        public static string ToFriendlyString(this EELFPFlags val)
        {
            if (val == EELFPFlags.PF_MASKOS || val == EELFPFlags.PF_MASKPROC)
            {
                return "ENV_SPECIFIC";
            }
            else
            {
                StringBuilder sb = new StringBuilder();

                if ((val & EELFPFlags.PF_X) != 0)
                {
                    sb.Append("E");
                }
                if ((val & EELFPFlags.PF_W) != 0)
                {
                    sb.Append("W");
                }
                if ((val & EELFPFlags.PF_R) != 0)
                {
                    sb.Append("R");
                }

                return sb.ToString();
            }
        }
    }
}
