﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ElfViewerConsole.ELFModel.ELFFormat.Enums
{
    enum EELFShType
    {
        [Description("Unused section header")]
        SHT_NULL = 0,

        [Description("Defined by program")]
        SHT_PROGBITS = 1,

        [Description("Linker symbol table")]
        SHT_SYMTAB = 2,

        [Description("String table")]
        SHT_STRTAB= 3,

        [Description("Relocation table")]
        SHT_RELA = 4,

        [Description("Symbol hash table")]
        SHT_HASH = 5,

        [Description("Dynamic linking table")]
        SHT_DYNAMIC = 6,

        [Description("Note information")]
        SHT_NOTE = 7,

        [Description("Uninitialized space")]
        SHT_NOBITS = 8,

        [Description("Relocation table")]
        SHT_REL = 9,

        [Description("Reserved table")]
        SHT_SHLIB = 10,

        [Description("Dynamic loader symbol table")]
        SHT_DYNSYM = 11,

        [Description("Array of pointers to initialization functions table")]
        SHT_INIT_ARRAY = 14,

        [Description("Array of pointers to termination functions table")]
        SHT_FINI_ARRAY = 15,

        [Description("Array of pointers to pre-initialization functions table")]
        SHT_PREINIT_ARRAY = 16,

        [Description("Section Group")]
        SHT_GROUP = 17,

        [Description("Extended section indices")]
        SHT_SYMTAB_SHNDX = 18,
    }
}
