﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ELFViewerConsole.ELFModel
{
    enum IFileAccessEndianess
    {
        LITTLE_ENDIAN = 0,
        BIG_ENDIAN = 1
    };

    interface IFileAccess
    {
        uint Position { get; set; }
        long Length { get; }
        byte[] RawData { get; }

        byte ReadByte(uint pos);
        ushort ReadUInt16(uint pos);
        short ReadInt16(uint pos);
        uint ReadUInt32(uint pos);
        int ReadInt32(uint pos);
        ulong ReadUInt64(uint pos);
        long ReadInt64(uint pos);

        byte ReadByte();
        ushort ReadUInt16();
        short ReadInt16();
        uint ReadUInt32();
        int ReadInt32();
        ulong ReadUInt64();
        long ReadInt64();

        byte[] ReadByteArray(uint length);

        void SetEndianess(IFileAccessEndianess type);

        string ReadAscii(uint pos, int maxLength);
    }
}
